<?php

/**
 * Class Easy_Translate_Translation_Updater.
 *
 * @package    Easy_Translate
 * @subpackage Easy_Translate/admin
 */
class Easy_Translate_Translation_Updater
{

    /**
     * Starts a translation update.
     *
     * @param $post_id
     */
    public function run($post_id)
    {

        if (get_post_meta($post_id, 'et_auto_translate', true) && Easy_Translate_Translation_List::compare_post_source_language($post_id) && Easy_Translate_Translation_List::check_dependencies()) {
            $a_string_id = array();
            $content[] = Easy_Translate_Translation_List::get_post_content($post_id, $a_string_id, false);

            if ($content[0]) {
                $source = Easy_Translate_Translation_List::get_source_language();
                $target_languages = Easy_Translate_Translation_List::get_translation_needs_update($post_id);

                if ($this->update_strings($source, $target_languages, $content)) {
                    Easy_Translate_Translation_List::update_string_status($a_string_id, Easy_Translate_Translation_List::STATUS_WAITING);
                    Easy_Translate_Translation_List::update_duplicate_status(array($post_id), $target_languages, Easy_Translate_Translation_List::STATUS_WAITING);
                }
            }
        }

    }

    /**
     * Send strings to translate.
     *
     * @param string $source
     * @param array $target
     * @param array $content
     * @return bool
     */
    protected function update_strings($source, $target, $content)
    {

        $options = get_option(EASY_TRANSLATE_INTEGRATION_OPTION);
        $service = new Easy_Translate_API_Laas(Easy_Translate_API_Integration::map_fields($options));
        $result = $service->translate($source, $target, $content);

        return !isset($result['error']);

    }

}
